#!/usr/local/bin/python3
#
#  	Dashboard Joiner for CW Dashboard aggregation
#	RTC April 2021
#
import os
import json
from json import JSONEncoder
import code
import time
import copy
from time import gmtime, strftime
import datetime
from datetime import datetime
import subprocess 
import os.path
from os import path
#
#
# -- DECLARE VARS ---#
myversion = "1.0"
CombinedWidgetsList = [""]
TotalWidgetsCount = 0
FileOpen = '{"widgets": ['
FileClose = ']}'
#
#-------------------------------------------------------------------------------------
print("\n\n","-- This script joins multiple dashboard scripts into one composite dashboard. --")
print("\n")
InputFiles = [str(x) for x in input("--> Enter two to five JSON dashboard file names to combine, separated by spaces: ").split(' ') ]
##L = [int(x) for x in input("Enter multiple values\n").split(', ')]
N = len(InputFiles)
if N < 2 :
	print("not enough files InputFiles.")
	exit()

## get inputs
for i in range(0,N) :
	#print ("item InputFiles[",i,"] was ", InputFiles[i])
	if not (path.isfile(InputFiles[i])):
		print("....Specified File -->", InputFiles[i] ,"<-- not found; please check specified inputs. Exiting.")
		exit()

## basic content check
for i in range(0,N) :
	cmd1 = "head -2 " + InputFiles[i] + '|grep -q widget && echo 1 ||echo 0'
	result = os.popen(cmd1).read()
	if not (result == '1\n'):
		print("---> File",InputFiles[i], "failed format check, sorry. Exiting.")
	
	else:
		## read the file into a var and remove open+ClosedPoolError
		print("\n","--->Parsing file", InputFiles[i])
		f = open(InputFiles[i],)
		fdata = json.load(f)
		fstring = json.dumps(fdata)
		#code.interact(local=globals())
		fstring = fstring.replace("\'","@") ## CHECK FOR escaped single quotes and substitute
		fstring = fstring.replace('\\"','~') ## CHECK FOR escaped quotes and substitute
		fdata = json.loads(fstring)
		##
		##code.interact(local=globals())
		## we now have the widget code from this file
		for z in range(0, (len(fdata['widgets']))):
			## get service name & remove prefix
			SN=fdata['widgets'][z]['properties']['metrics'][0][0]
			SN=SN[4:]
			## 
			##  Set new widget title prefixes
			Prefix="AWS"
			if (SN == 'MediaConnect'):
				Prefix = "MX"
		
			if (SN == 'MediaLive'):
				Prefix = "ML"
				
			if (SN == 'aLive'):
				Prefix = "ML"	
		
			if (SN == 'MediaPackage'):
				Prefix = "MP"
			
			if (SN == 'MediaStore'):
				Prefix = "MS"	
			
			if (SN == 'MediaConvert'):
				Prefix = "MC"	
			
			if (SN == 'S3'):
				Prefix = "S3"		
		
			fdata['widgets'][z]['properties']['title'] = Prefix + ":" + fdata['widgets'][z]['properties']['title']
			#code.interact(local=globals())
		##
		##
		
		WC = len(fdata['widgets'])
		print("----> Extracting",WC, "Widgets from ",InputFiles[i])
		for j in range(0,WC):
			CombinedWidgetsList.append('')
			CombinedWidgetsList[TotalWidgetsCount] = fdata['widgets'][j]
			TotalWidgetsCount = TotalWidgetsCount + 1

		
print("\n","---> Found a total of",TotalWidgetsCount, "Widgets...\n")
#print("And CombinedWidgetsList reads:", CombinedWidgetsList)



# ------------------------------------------------------------------------------------

## now we assemble the complete json 
tnow = datetime.now()
tstamp = tnow.strftime("%m%d%y_%H%M%S")
## 
##  Start Assembling full JSON as a list of strings 
#
FullJSON = FileOpen
for counter in range (0, len(CombinedWidgetsList)) :
	S = str(CombinedWidgetsList[counter])
	#S = S.replace('(','')
	#S = S.replace(')','')
	S = S.replace("'",'"')
	S = S.replace("@","'")
	S = S.replace('~','\\"')
	S = S.replace('"false"','false')
	S = S.replace('False','false')
	S = S.replace('"true"','true')
	S = S.replace('True','true')
	S+=","
	FullJSON+=S
##
##remove the comma after final widget and finish the JSON
FullJSON = FullJSON[:-2]
FullJSON+=FileClose
##
print("")
dashfile = "dashjson_" + tstamp + ".json"
f = open(dashfile, 'w')
f.write(FullJSON) 
f.close()
tyellow="\033[1;33;40m"
tnormal="\033[0;37;40m"
print(tnormal,"\n")

print("----> Dash JSON exported to local file '", dashfile, "' for future reference." )    
##
### now create the dashboard 
dashname = "Combined_Dash_" + tstamp
dashcmd = "aws cloudwatch put-dashboard --dashboard-name "+ dashname +" --dashboard-body file://" + dashfile
print("\n","=================================================================","\n")
print(" Attempting to create new dashboard ",tyellow,dashname,tnormal, "in your CW Console. You can rename the dash via the Console.")
try: 
	dashresult = os.popen(dashcmd).read()
	
except: 
	"Got an error on upload. Please check the json file syntax. Exiting."
	exit()
	
print("\n\n"," Cloudwatch upload result was: (empty [ ] means no errors) ","\n",dashresult)
#code.interact(local=globals())
#print("Try running cmd: ", dashcmd)
print(" Remember to set the time range for your new Dashboard (upper right corner of CW Console).")

exit()